{                            MGF v1.2 by F.Cheveau                           }

{Algorithme de transformation d'une image BMP en MGF par supression
des 16 premires couleurs de la palette sur une palette 256 couleurs.

(C)1996 F.Cheveau as Zuul as BouFFtou.

Lecture des donnes de l'image:
 - Stockage de la table des couleurs dans un tableau du nom de "TC".
 - Stockage des points du gfx dans un tableau en XMS du nom de "TP".

Description des variables locales utilises:

  A,B,C     : Boucles
  QttUsedCol: Nombre de couleurs utilises par l'image parmis les 16 premires
  QttFreeCol: Nombre de couleurs libres (non utilises) parmis les 255-16 de l'image
  QttC      : Nombre de couleurs de l'image BMP
  QttP      : Nombre de pixels de l'image BMP
  R1,G1,B1  : Valeurs RGB de la couleur 1
  R2,G2,B2  : Valeurs RGB de la couleur 2
  Coul1     : Variable de stockage du numro de couleur
  Coul2     : Variable de stockage du numro de couleur

Description des variables globales utilises:

  TC      : Array[0..QttC,0..2] of Integer;  : Tableau des couleurs : QttC = 255
  TCBusy  : Array[0..15] of Integer;    : Tableau des couleurs utilises par l'image parmis les 16 premires
  TCBusy2 : Array[16..QttC] of Integer; : Tableau des couleurs utilises par l'image parmis les 255-16 de l'image
  TP      : Array[0..QttP] of Integer;  : Tableau des couleurs : QttP = n
}

{****************************************************************************}
{***                                                                      ***}
{***                         A L G O R I T H M E                          ***}
{***                                                                      ***}
{****************************************************************************}

Program BMP_To_MGF;

Uses MOS_XMS,Crt,Dos;

{ͻ
                        VARIABLES DECLAREES PAR ZUUL                        
 ͼ}

Const  QttC = 255;                       {*Taille de la palette*}

Var
  Error    :Byte;                        {*Gestion des Erreur*}
  Par      :String;                      {*Gestion des Paramtres*}
  Source   :String;                      {*Nom du fichier Source*}
  Target   :String;                      {*Nom du fichier destination*}
  Rapport  :String;                      {*Nom du fichier de Rapport*}
  Fr       :Text;                        {*Fichier Rapport*}
  Path     :DirStr;
  Name     :NameStr;
  Ext      :ExtStr;
  Mode     :Byte;                        {*Mode de Modification de l'Image*}
  SDiff    :Longint;                     {*Somme des Min_Diff*}
  Force    :Byte;                        {*Forage du format de Sauvegarde*}
  NoMess   :Boolean;                     {*Pas d'affichage  l'cran*}
  Save_Info:Boolean;                     {*Save les Infos sur la Compression*}
  A        :Integer;                     {*Loop*}
  Oui      :Boolean;                     {*Rponds OUI  toutes les quetions Poses*}
  CSuc     :Integer;                     {*Nombre de couleurs  Supprimer*}
  DejaConv :Boolean;                     {*Image dja au format MGF ???*}

  TC       :Array[0..QttC,0..3] of Byte; {*Couleurs RGB ???*}
  TCTag    :Array[0..QttC] of Integer;   {*Tableau des couleurs tagges*}

  QttP     :Longint;                     {*Taille de l'image*}

{ͻ
                      VARIABLES DECLAREES PAR SYBARIS                       
 ͼ}

Type bmpHeader=Record
       ID    : Array[1..2] of char;     { 'BM' for a Windows BitMaP }
       FSize : LongInt;  { Size of file }
       Ver   : LongInt;  { BMP version (?), currently 0 }
       Image : LongInt;  { Offset of image into file }
       Misc  : LongInt;  { Unknown, appears to be 40 for all files }
       Width : LongInt;  { Width of image }
       Height: LongInt;  { Height of image }
       Num   : Word;     { Not sure, possibly number of images or planes (1) }
       Bits  : Word;     { Number of bits per pixel }
       Comp  : LongInt;  { Type of compression, 0 for uncompressed, 1,2 for RLE }
       ISize : LongInt;  { Size of image in bytes }
       XRes  : LongInt;  { X dots per metre (not inches! for US, unbelievable!) }
       YRes  : LongInt;  { Y dots per metre }
       PSize : LongInt;  { Palette size (number of colours) if not zero }
       Res   : LongInt;  { Probably reserved, currently 0 }
     End;                { 54 bytes }

Type TPalette = Record
       b,g,r,x : Byte;   { BMP uses a fourth byte for the palette, not used }
     End;

Type Typ_buffer=array[1..1284] of byte;

Var F               : file;
    header          : BMPHeader;
    E               : Word;      {Erreur lors de la lecture }
    ScreenX,ScreenY : word;
    Colors          : longint;
    Compression     : Boolean;
    TAB_XMS         : xms_tab;
    Buff            : ^typ_buffer;
    L,i,j           : Word;
    TQP             : Array[0..Qttc] of longint;{*Tableau des Quantits de Points*}
    Errorsyb        : Boolean;

{ͻ
                      LE CODE QUI SUIT EST DE SYBARIS                       
 ͼ}

Procedure Load_Palette;
Var palette : TPalette;
    i,nBits : Word;
Begin
 If header.PSize=0 Then
  Case header.Bits Of
   1 : nbits:=2;  { These are the only valid bits in a BMP }
   4 : nbits:=16;
   8 : nbits:=256;
   24: nbits:=0;  { A 24 bit image does not have a palette }
  End else nbits:=header.PSize;
 For i:=0 To nbits-1 Do
  Begin
   BlockRead(f,palette,4);
   With Palette do If (I=0) And (R=70) And (G=71) And (B=77)
      Then DejaConv:=True;             {*Image dja au format MGF...*}
   TC[i,0]:=palette.r Shr 2;
   TC[i,1]:=palette.g Shr 2;
   TC[i,2]:=palette.b Shr 2;
  End;
End;

{ͻ
                        LE CODE QUI SUIT EST DE ZUUL                        
 ͼ}

{ͻ
                            FONCTIONS DE SERVICES                           
 ͹
  Gestion des strings, paramtres...                                        
 ͼ}

Function UPPER(SUP:String):String;      {*Passe en Majuscules*}
Var I:Integer;
    ST1:String;
Begin
St1:=SUP;
For I:=1 to Length(ST1) do
ST1[I]:=Upcase(ST1[I]);
UPPER:=ST1;
End;

Function Parameter(Var St:String):Byte; {*Renvois le Paramtre Demand*}
Var A,PP:Integer;
    P:String;
Begin
Parameter:=0;                           {*De Base*}
For A:=1 to ParamCount do
   Begin
   P:=Upper(ParamStr(A)); St:=Upper(St);{*Passe tout en Majuscule*}
   If Pos(St,P)>0 Then Begin            {*Found Paramtre*}
      PP:=Pos('=',P);                   {*Search for Sous-Paramtre...*}
      If PP>0 Then St:=Copy(P,PP+1,Length(P)-PP+1);
      Parameter:=A;                     {*Renvois Numro Paramtre dans Liste*}
      End;
   End;
End;

Function TEST_FILE_EXIST(Name:String):Boolean;
Var Fichier:Text;
Begin
Test_File_Exist:=False;
If Name='' Then Exit;                {*Pas de noms de Fichier*}
Assign(Fichier,Name);
{$I-}
Reset(Fichier);
{$I+}
If IOResult=0 Then                   {*Pas d'erreurs*}
   Begin
   Test_File_Exist:=True;            {*Renvois Rsultat*}
   Close(Fichier);
   End
End;

{ͻ
                          CHARGEMENT DE L'IMAGE BMP                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Ouvre le fichier BMP et charge les couleurs et l'image dans des  
           tableaux en mmoire XMS.                                         
 ͼ}

Procedure LOAD_BMP;
Const Points='..............................';
Begin
Source:=Path+Name+Ext;                         {*Cre le nom Source*}
If Not NoMess Then Write('Lecture de ',Source,Copy(Points,1,22-Length(Source)),' ');
If Save_Info Then Write(Fr,'Lecture de ',Source,Copy(Points,1,22-Length(Source)),' ');

{*Partie de code by Sybaris*}

 Assign(F,Source);
 {$i-}
 Reset(F, 1);
 {$i+}
 if ioresult=0 then
  begin
   {$i-}
   Blockread(F,header,SizeOf(header),E);
   {$i+}
   If (ioresult<>0) or (e<>Sizeof(header)) then
    begin
     close(f);                                 {*Pas le format BMP !!!*}
     If Not NoMess Then Writeln('Cette image n''est pas au format BMP...');
     If Save_Info  Then Writeln(Fr,'Cette image n''est pas au format BMP...');
     exit;
    end;
   With header DO
   begin
    If (ID='BM') or (ID='bm') then
     begin
      ScreenX:=width;
      ScreenY:=height;
      Qttp:=ScreenX*ScreenY-1;
      If PSize=0 Then Case Bits Of
        1 : colors:=2;         { These are the only valid bits in a BMP }
        4 : colors:=16;
        8 : colors:=256;
        24: colors:=16777216;  { A 24 bit image does not have a palette }
      End else colors:=Psize;
      Compression:=header.comp<>0;
     end Else
        Begin                                  {*Mauvaise Entte de Fichier*}
        If Not NoMess Then Writeln('L''entte du fichier ',Source,' ne correspond pas  un fichier BMP...');
        If Save_Info  Then Writeln('L''entte du fichier ',Source,' ne correspond pas  un fichier BMP...');
        Exit;
        End;
   end;
   If Not NoMess Then Begin                    {*Affiche Infos sur l'Image*}
      TextColor(14); Writeln('Ok'); TextColor(7);
      Writeln('   Largeur de l''image........... ',ScreenX);
      Writeln('   Hauteur de l''image........... ',ScreenY);
      Writeln('   Compression RLE.............. ',Compression);
      Writeln('   Nombre de couleurs........... ',Colors);
      End;
   If Save_Info Then Begin
      Writeln(Fr,'Ok');
      Writeln(Fr,'   Largeur de l''image........... ',ScreenX);
      Writeln(Fr,'   Hauteur de l''image........... ',ScreenY);
      Writeln(Fr,'   Compression RLE.............. ',Compression);
      Writeln(Fr,'   Nombre de couleurs........... ',Colors);
      End;
   If (colors=256) and Not compression then
    begin
     {--------------}
       for i:=0 to Qttc do TQP[i]:=0;    { --> Initialisation des tableaux }
       Load_Palette;
       If init_tab_xms(Tab_Xms,1,ScreenY,Buff^,1284) then
        Begin
         l:=0;
         Repeat
          inc(l);
          blockread(f,buff^,ScreenX,e);
          Put_tab_xms(Tab_xms,l,Buff^);
          For i:=1 to ScreenX do
           Begin
            inc(TQP[Buff^[i]]);                {*Compte le nombre de points pour Chaque Couleur*}
           End;
         Until l=ScreenY;
        End Else Begin
           ErrorSyb:=True;
           If Not NoMess Then Writeln('Pas assez de mmoire XMS libre...');
           If Save_Info  Then Writeln(Fr,'Pas assez de mmoire XMS libre...');
           End;
     {--------------}
    end else Begin                             {*Impossible de Traiter l'Image*}
       ErrorSyb:=True;
       If Not NoMess Then Begin
          If Compression Then Writeln('Impossible de traiter une image compresse en RLE...');
          If Colors<>256 Then Writeln('L''image doit avoir 256 couleurs et non ',Colors,' couleurs...');
          End;
       If Save_Info Then Begin
          If Compression Then Writeln(Fr,'Impossible de traiter une image compresse en RLE...');
          If Colors<>256 Then Writeln(Fr,'L''image doit avoir 256 couleurs et non ',Colors,' couleurs...');
          End;
       End;
  end
  else Begin
     If Not NoMess Then Writeln('Impossible d''accder au fichier ',Source,'...');
     If Save_Info  Then Writeln(Fr,'Impossible d''accder au fichier ',Source,'...');
     End;

Close(f);
End;

{ͻ
                          SAUVEGARDE DE L'IMAGE MGF                         
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Cr le fichier MGF contenant l'image retravaille.              
 ͼ}

Procedure SAVE_MGF;
Const Points='..........................';
Var BmpFile:File;
    i,j:Word;
    Pal:Tpalette;
Begin
If Force=1 Then Begin                          {*Force la BMP*}
   If Not NoMess Then Writeln('Forage de la sauvegarde......... Format BMP');
   If Save_Info Then Writeln(Fr,'Forage de la sauvegarde......... Format BMP');
   End;
If Force=2 Then Begin                          {*Force la MGF*}
   If Not NoMess Then Writeln('Forage de la sauvegarde......... Format MGF');
   If Save_Info Then Writeln(Fr,'Forage de la sauvegarde......... Format MGF');
   End;

If SDiff>0 Then Begin
   If Save_Info Then Begin
      Writeln(Fr);
      Writeln(Fr,'L''image  t altre due  une compression partielle des couleurs.');
      Writeln(Fr,'il en rsulte une lgere perte de qualit de l''image...');
      If Force<>1 Then Writeln(Fr,'L''image va donc tre sauvegarde au format MGF');
      If Force<>1 Then Writeln(Fr,'Pour ne pas craser l''image BMP initiale.');
      End;
   If Not NoMess Then Begin
      TextColor(15);
      Writeln;
      Writeln('L''image  t altre due  une compression partielle des couleurs.');
      Writeln('il en rsulte une perte de qualit de l''image...');
      If Force<>1 Then Writeln('L''image va donc tre sauvegarde au format MGF');
      If Force<>1 Then Writeln('Pour ne pas craser l''image BMP initiale.');
      TextColor(7);
      End;
   Target:=Path+Name+'.MGF';                   {*Crer le nom Destination*}
   End Else
   Target:=Path+Name+'.BMP';                   {*Crer le nom Destination*}

If Force=1 Then Target:=Path+Name+'.BMP';      {*Force la BMP*}
If Force=2 Then Target:=Path+Name+'.MGF';      {*Force la MGF*}

If (Not NoMess) And (Error>0) Then Begin
   Writeln; TextColor(12);
   Target:=Path+Name+'.ERR';                   {*Erreur dans l'Image*}
   Writeln('                         ! ATTENTION !');
   TextColor(15);
   If Error=2 Then Writeln('Une Erreur est survenue lors de la relocation des couleurs.');
   If Error=1 Then Writeln('Une Erreur est survenue lors de la compression des couleurs.');
   Writeln('Il est probable que l''image rsultante soit partiellement endommage.');
   Writeln('Par consquent, elle va tre sauvegarde sous le nom : ',Target);
   If Save_Info Then Begin
      Writeln(Fr,'                         ! ATTENTION !');
      If Error=2 Then Writeln(Fr,'Une Erreur est survenue lors de la relocation des couleurs.');
      If Error=1 Then Writeln(FR,'Une Erreur est survenue lors de la compression des couleurs.');
      Writeln(Fr,'Il est probable que l''image rsultante soit partiellement endommage.');
      Writeln(Fr,'Par consquent, elle va tre sauvegarde sous le nom : ',Target);
      End;
   End;

TextColor(7);
If Not NoMess Then Begin Writeln;
   Write('Ecriture de ',Target,Copy(Points,1,21-Length(Source)),' ');{*Affichage de l'criture*}
   End;

If Save_Info Then Begin Writeln(Fr); Write(Fr,'Ecriture de ',Target,Copy(Points,1,21-Length(Source)),' '); End;

{* CODE BY SYBARIS *}

Assign(BmpFile,Target);
Rewrite(BmpFile,1);
BlockWrite(BmpFile,Header,Sizeof(Header));
For i:=0 To Qttc Do
 Begin
  If I>=CSuc Then Begin                     {*Ne Sauve que les couleurs >=16*}
     TC[i,0]:=TC[i,0] Shl 2;
     TC[i,1]:=TC[i,1] Shl 2;
     TC[i,2]:=TC[i,2] Shl 2;
     End;
  Pal.r:=TC[i,0];                           {*Stocke dans la Structure Color*}
  Pal.g:=TC[i,1];
  Pal.b:=TC[i,2];
  BlockWrite(BmpFile,Pal,Sizeof(Pal));
 End;
{BlockWrite(BmpFile,TC,Sizeof(TC));}
For j:=1 to ScreenY do
 Begin
  Get_tab_xms(Tab_xms,j,Buff^);
  BlockWrite(BmpFile,Buff^,ScreenX);
 End;

{* CODE BY ZUUL *}

If Not NoMess Then Begin TextColor(14); Writeln('Ok'); TextColor(7); End;
If Save_Info Then Writeln(Fr,'Ok');
End;

{ͻ
               AFFICHE INFOS SUR LA QTT DE PIXELS PAR COULEURS              
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
 ͼ}

Procedure GESTION_PIXELS;                   {*Affiche Stats Sur Pixels*}
Var A:Integer;
    Min,Max:Longint;                        {*Qtt Min et Max des Points Utiliss*}
    CMin,CMax:Integer;                      {*Numro des Couleurs de Min et Max*}
Begin
Min:=TQP[0]; Max:=TQP[0];                   {*Init All*}
For A:=1 to QttC do Begin                   {*Parcours le Tableau*}
   If TQP[A]>Max Then Begin Max:=TQP[A]; CMax:=A; End;
   If TQP[A]<Min Then Begin Min:=TQP[A]; CMin:=A; End;
   End;

If Save_Info Then Begin
   Writeln(Fr);
   Writeln(Fr,'Couleur la moins utilise........ ',CMin,' / Pixels = ',Min);
   Writeln(Fr,'Couleur la plus utilise......... ',CMax,' / Pixels = ',Max);
   End;
End;

{ͻ
                   SAUVEGARDE DES INFOS SUR LA COMPRESSION                  
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Cr un fichier info contenant les dtails de la compression.    
 ͼ}

Procedure CREATE_INFOS;
Var Ch:Char;
Begin
If Test_File_Exist(Rapport) Then Begin      {*Test si Fichier Existe Dja*}
   If Not NoMess Then Begin
      Write('Le fichier ',Rapport,' existe dja, voulez-vous l''craser (O/N) ? ');
      If Not OUI Then
         Repeat
         Ch:=Upcase(Readkey);               {*Oui ou Non*}
         Until (Ch='O') Or (Ch='N')
         Else Ch:='O';                      {*Rponds Oui de Base...*}
      Writeln(Ch);                          {*Affiche Rsultat*}
      End
      Else Ch:='O';
   If Ch='N' Then Exit;                     {*Ecrase le Fichier*}
   End;

Save_Info:=True;                            {*Confiramtion Sauvegarde*}
Assign(Fr,Rapport);
{$I-}
Rewrite(Fr);                                {*Cration du Fichier de Rapport*}
{$I+}
If IOResult=0 Then Begin
   Writeln(Fr,'Fichier Rapport de la conversion de l''image ',Path+Name+Ext);
   Writeln(Fr);
   End;
End;

{ͻ
                          CONVERSION DE BMP EN MGF                          
 ͹
  IN.....: /                                                                
  OUT....: /                                                                
  EXPLAIN: Convertit en mmoire l'image au format BMP en format MGF.        
           La seule diffrence, rside dans le fait que le format MGF laisse
           libre les 16 premires couleurs de la palette des 256.           
 ͼ}

Procedure CONVERSION;
Var
  A,B          :Integer;
  QttUsedCol16 :Integer;
  QttUsedColOt :Integer;
  Coul1        :Integer;
  Coul2        :Integer;
  DR,DG,DB     :Longint;                    {*Delta des RGB pour Couleur Approchante*}
  MDR,MDG,MDB  :Longint;                    {*Minimum des Deltas des RGB*}
  Diff         :Longint;                    {*Coefficient DR+DG+DB*}
  Min_Diff     :Longint;                    {*Plus petit Coefficient*}
  CApp         :Integer;                    {*Indice de la couleur la plus Approchante*}
  Alter        :Boolean;                    {*ALtration de l'image ?*}

{****************** RELOCATION DES 16 PREMIERES COULEURS ********************}

Procedure RELOC_COLORS;
Var C,X,Y:Integer;
Begin
A:=0; B:=CSuc;                        {*Couleur 0 et N (16)*}
X:=WhereX; Y:=WhereY;                 {*Keep Pos de Dpart*}
Repeat
   If TCTag[A]>0 Then Begin
      Coul1:=A;                       {*Couleur  dplacer...*}
      Coul2:=0;
      While (B<256) And (Coul2=0) do Begin
         If TCTag[B]=0 Then Begin     {*Couleur Libre...?*}
            Coul2:=B;
            Gotoxy(X,Y); TextColor(15);     {*Show Result*}
            If Not NoMess Then Writeln(Coul1,' -> ',Coul2,'   ');
            If Save_Info Then Writeln(Fr,'Col ',Coul1:2,' -> Col ',Coul2,'   ');
            TC[Coul2,0]:=TC[Coul1,0];
            TC[Coul2,1]:=TC[Coul1,1]; {*Echange des deux Couleurs*}
            TC[Coul2,2]:=TC[Coul1,2];
            TCTag[Coul2]:=1;          {*Taggue la couleur B comme Utilise*}

            For j:=1 to ScreenY do    {*Parcours l'image*}
               Begin
               Get_tab_xms(Tab_xms,j,Buff^);
               for i:=1 to ScreenX do {*Remplace Couleur*}
                  If Buff^[i]=Coul1 then Buff^[i]:=Coul2;
               Put_Tab_xms(Tab_xms,j,Buff^);
               End;

            End;
         Inc(B);                      {*Recherhe Couleur Libre*}
         End;
      If (B=256) And (A<=CSuc-1) Then Begin
         If Mode=2 Then Begin TextColor(12);  {*Red for ERRORS*}
            If Not NoMess Then Writeln('ERREUR : Plus assez de couleurs libre pour la relocation !');
            If Save_Info Then Writeln(Fr,'ERREUR : Plus assez de couleurs libre pour la relocation !');
            TextColor(7); Error:=2;   {*Erreur !*}
            End;
         TCTag[Coul1]:=2;             {*Taggue la couleur A pour Compression*}
         End
      Else TCTag[Coul1]:=1;           {*Taggue la couleur A comme Utilise*}
      End;
   Inc(A);                            {*Next Color*}
Until A>CSuc-1;                       {*Jusqu' la Nime Couleur ou Tableau Full*}
If Not NoMess Then Begin
   TextColor(14);Gotoxy(X,Y); Writeln('Ok                ');
   End;
TextColor(7);
End;

{************* COMPRESSION DES 16 PREMIERES COULEURS RESTANTES **************}

Procedure COMPRESS_COLORS;
Var A,B,C,X,Y:Integer;
Begin
A:=0; SDiff:=0;                       {*Begin by Couleur 0*}
X:=WhereX; Y:=WhereY;                 {*Keep Pos de Dpart*}
Repeat                                {*Recherche une Couleur Approchante*}
If TCTag[A]=2 Then                    {*Couleur  Dplacer ?*}
   Begin
   Coul1:=A;                          {*Oui ! C'est une Couleur  Dplacer !*}
   CApp:=-1; Min_Diff:=12289;         {*Maximum indpassable*}
   For B:=CSuc to QttC do Begin       {*Parcourir les 255-N(16) autres couleurs*}
       Coul2:=B;
       DR:=Abs((TC[Coul1,0]-TC[Coul2,0])*(TC[Coul1,0]-TC[Coul2,0]));
       DG:=Abs((TC[Coul1,1]-TC[Coul2,1])*(TC[Coul1,1]-TC[Coul2,1]));
       DB:=Abs((TC[Coul1,2]-TC[Coul2,2])*(TC[Coul1,2]-TC[Coul2,2]));
       Diff:=DR+DG+DB;                {*Calcul Coef Couleur Approchante*}
       If Diff<Min_Diff Then Begin
          Min_Diff:=Diff; CApp:=B;    {*Couleur la plus Approchante*}
          MDR:=Round(Sqrt(DR)); MDG:=Round(Sqrt(DG)); MDB:=Round(Sqrt(DB));
          End;                        {*Save Minimum des Delta RGB*}
      End;
   If CApp<>-1 Then Begin             {*Assimilation des deux Couleurs*}
      Gotoxy(X,Y); TextColor(15);     {*Show Result*}
      If Not NoMess Then Writeln(Coul1:2,' -> ',CApp,' -  = ',Min_Diff,'     ');
      If Save_Info Then Begin Write(Fr,'Col ',Coul1:2,' -> Col ',CApp:3,' -  = ',Min_Diff:3);
                        Writeln(Fr,'     Delta R=',MDR:2,'   Delta G=',MDG:2,'   Delta B=',MDB:2); End;
      SDiff:=SDiff+Min_Diff;          {*Somme des diffrences*}

      For j:=1 to ScreenY do          {*Parcours l'image*}
         Begin
         Get_tab_xms(Tab_xms,j,Buff^);
         for i:=1 to ScreenX do
            If Buff^[i]=Coul1 Then
               Begin
               Buff^[i]:=CApp;
               TCTag[Coul2]:=1;       {*Taggue la couleur comme Utilise*}
               End;
         Put_Tab_xms(Tab_xms,j,Buff^);{*Refout le bordel en XMS*}
         End;

      End
      Else If Not NoMess Then Begin TextColor(12); Error:=1;
              If Not NoMess Then Writeln('ERREUR : Couleur approchante non trouve !');
              If Save_Info Then Writeln(Fr,'ERREUR : Couleur approchante non trouve !');
              TextColor(7);
              End;                    {*ERROR !*}
   End;
Inc(A);                               {*Next Color Parmis les N(16) Premires*}
Until A>CSuc-1;                       {*Parcours les N(16) Premires Couleurs*}
If Not NoMess Then Begin
   TextColor(14); Gotoxy(X,Y); Writeln('Ok                   ');
   TextColor(7); Write('Coefficient d''altration......... ');
   TextColor(12); Writeln(SDiff);     {*Affiche Altration de l'image*}
   End;
If Save_Info Then Writeln(Fr,'Coefficient d''altration......... ',SDiff);
End;                                  {*Fin de l'algo de Compression de Couleurs*}

{************************** MAIN CODE CONVERSION ****************************}

Begin
For A:=0 to QttC do TCTag[A]:=0;            {*Vide le tableau des couleurs utilises*}

For j:=1 to ScreenY do                      {*Recherche des couleurs utilises*}
   Begin
   Get_tab_xms(Tab_xms,j,Buff^);            {*Cette couleur est utilis par l'image !*}
   for i:=1 to ScreenX do TCTag[Buff^[i]]:=1;
   Put_Tab_xms(Tab_xms,j,Buff^);
   End;

QttUsedCol16:=0;
QttUsedColOt:=0;
For A:=0 to QttC do                         {*Compte le nombre de couleurs utilises*}
   If TCTag[A]>0
      Then If A<=CSuc-1 Then Inc(QttUsedCol16)  {*Qtt de couleurs utilises dans les N(16) Premires*}
                    Else Inc(QttUsedColOt); {*Qtt de couleurs utilises dans les 256-N(16)*}

If Not NoMess Then Begin
   If CSuc<>16 Then Begin Write('Nombre de couleurs  liminer.... '); TextColor(14); Writeln(CSuc); TextColor(7); End;
   Write('Couleurs utilises (  0->',CSuc-1:3,').... '); TextColor(14); Writeln(QttUsedCol16); TextColor(7);
   Write('Couleurs utilises (',CSuc:3,'->255).... '); TextColor(14); Writeln(QttUsedColOt); TextColor(7);
   Write('Couleurs utilises (  0->255).... '); TextColor(14); Writeln(QttUsedCol16+QttUsedColOt); TextColor(7);
   Write('Couleurs libres    (',CSuc:3,'->255).... '); TextColor(14); Writeln(256-CSuc-QttUsedColOt); TextColor(7);
   End;

If Save_Info Then Begin
   Writeln(Fr);
   Writeln(Fr,'Nombre de couleurs  liminer.... ',CSuc);
   Writeln(Fr,'Couleurs utilises (  0->',CSuc-1:3,').... ',QttUsedCol16);
   Writeln(Fr,'Couleurs utilises (',CSuc:3,'->255).... ',QttUsedColOt);
   Writeln(Fr,'Couleurs utilises (  0->255).... ',QttUsedCol16+QttUsedColOt);
   Writeln(Fr,'Couleurs libres    (',CSuc:3,'->255).... ',256-CSuc-QttUsedColOt);
   End;

If QttUsedCol16=0 Then Begin                {*Pas besoin de modifier l'image !*}
   Mode:=1; Error:=3;
   If Not NoMess Then Begin Writeln; Write('Pas de modifications ncessaires. ');
      Textcolor(14); Writeln('Ok'); TextColor(7);
      If Save_Info Then Begin Writeln(Fr); Writeln(Fr,'Pas de modifications ncessaires. Ok'); End;
      End;
   End
   Else Begin                               {*Ncessite un traitement de l'image*}
   If 256-CSuc-QttUsedColOt<QttUsedCol16 Then {*Y-a-t'il suffisamment de couleurs libres ?*}
      Begin                                 {*NON ! => COMPRESSIONS DES COULEURS*}
      Mode:=3;
      If Not NoMess Then Write('Relocation des couleurs.......... ');
      If Save_Info Then Begin Writeln(Fr); Writeln(Fr,'Relocation des couleurs.......... En cours'); End;
      RELOC_COLORS;                         {*Relocation des Couleurs*}
      If Not NoMess Then Write('Compression des couleurs......... ');
      If Save_Info Then Begin Writeln(Fr); Writeln(Fr,'Compression des couleurs......... En cours'); End;
      COMPRESS_COLORS;                      {*Compression des Couleurs*}
      End                                   {*Fin de la Compression de Couleurs*}
      Else Begin                            {*OUI ! => TRANSFERT DES COULEURS*}
      Mode:=2;
      If Not NoMess Then Write('Relocation des couleurs.......... ');
      If Save_Info Then Begin Writeln(Fr); Writeln(Fr,'Relocation des couleurs.......... En cours'); End;
      RELOC_COLORS;                         {*Relocation des Couleurs*}
      End;                                  {*Fin du Transfert de Couleurs*}
   End;                                     {*Fin du Traitement de l'Image*}
End;

{************************** PROGRAMME PRINCIPAL *****************************}

Begin
Error:=0;                                   {*Pas d'erreurs de Base*}
Oui:=False;
CSuc:=16;                                   {*De base 16 Couleurs  Virer*}
Errorsyb:=False;
DejaConv:=False;                            {*Image de base pas au format MGF*}
TextColor(7);

Par:='/NM';
If Parameter(Par)>0 Then NoMess:=True       {*Pas d'affichage  l'cran*}
                    Else NoMess:=False;

If Not NoMess Then Clrscr;                  {*Clear Screen*}

If Not NoMess Then Begin
   Writeln('BMP to MGF v1.2');
   Writeln('Convertisseur d''images BMP (256 couleurs) au format BMP/MGF (240 couleurs)');
   Writeln('(C)1996 F.Cheveau. Tel: 68.50.77.15');
   Writeln('Le format MGF est utilis par l''interface graphique MOS v2.4.');
   Writeln;
   End;

Par:='/?';
If Parameter(Par)>0 Then Begin
   Source:=ParamStr(0);
   FSplit(Source,Path,Name,Ext);
   Writeln('Synopsis : ',Name,Ext,' <FichierSource> /Paramtres');
   Write  ('           Le fichier source doit tre une image BMP 256 couleurs non compresse');
   Writeln('           Les extentions fichiers sont facultatives');
   Writeln;
   Writeln('Paramtres : /FB           = Force la sauvegarde au format BMP');
   Writeln('             /FM           = Force la sauvegarde au format MGF');
   Writeln('             /SI=<Name>    = Sauvegarde les informations sur la transformation');
   Writeln('             /NM           = Ne fait aucun affichage cran');
   Writeln('             /O            = Rponds OUI  toutes les questions poses');
   Writeln('             /C=<Quantit> = Nombre de couleurs  supprimer (Dfaut = 16)');
   Exit;
   End;

Par:='/O';
If Parameter(Par)>0 Then OUI:=True;         {*Rponds OUI  toutes les questions poses*}

Par:='/C';
If Parameter(Par)>0 Then                    {*Spcifie le nombre de couleurs  Virer*}
   If Par<>'/C' Then Begin
      Val(Par,CSuc,A);
      If A<>0 Then Begin
         Writeln('Vous devez spcifier clairement le nombre de couleurs  extraire...');
         Exit;
         End;
      If (CSuc<0) Or (CSuc>256) Then Begin
         Writeln('Le nombre de couleurs  extraire doit tre compris entre 0 et 256...');
         Exit;
         End;
      End;

Force:=0;                                   {*Pas de forage du format de Sauvegarde*}
Par:='/FB';
If Parameter(Par)>0 Then Force:=1;          {*Force Save to BMP*}
Par:='/FM';
If Parameter(Par)>0 Then Force:=2;          {*Force Save to MGF*}

Source:='';
For A:=1 to ParamCount do                   {*Rcupre le Nom du Fichier*}
   If Copy(ParamStr(A),1,1)<>'/' Then Source:=Upper(ParamStr(A));
If Source='' Then Begin                     {*Pas de Source Spcifie*}
   If Not NoMess Then Writeln('Vous devez spcifier un fichier image BMP...');
   Exit;
   End;
FSplit(Source,Path,Name,Ext);
If Ext='' Then Ext:='.BMP';                 {*Vrifie l'extension*}
If Not Test_File_Exist(Path+Name+Ext) Then
   Begin                                    {*File Not Exist*}
   If Not NoMess Then Writeln('Fichier ',Path+Name+Ext,' introuvable...');
   Exit;
   End;

Par:='/SI';
If Parameter(Par)>0 Then Begin              {*Sauvegarde des Infos*}
   If Par='/SI' Then Begin
      Rapport:=Path+Name+'.RAP';            {Nom automatique**}
      End Else Rapport:=Upper(Par);         {*Nom du Fichier de Rapport*}
   CREATE_INFOS;                            {*Sauvegarde les infos sur la compression*}
   End;

if Maxavail>=1284 then
  Begin
  New(Buff);
  End Else Begin
   If Not NoMess Then Writeln('Pas assez de mmoire conventionnelle...');
   If Save_Info  Then Writeln(Fr,'Pas assez de mmoire conventionnelle...');
   Exit;
   End;

LOAD_BMP;                                   {*Charge la BMP en Mmoire XMS*}
If ErrorSyb=True Then Exit;                 {*Erreur Grave Survenue !!!*}
If DejaConv=True Then Begin
   Writeln; TextColor(15); Write('L''image est dja au format MGF... ');
   TextColor(14); Writeln('Ok'); TextColor(7); Writeln;
   If Save_Info Then Begin Writeln(Fr); Writeln(Fr,'L''image est dja au format MGF... Ok'); End;
   End;

GESTION_PIXELS;                             {*Affiche Stats Sur Pixels*}

CONVERSION;                                 {*Appel de la procdure de conversion*}

TC[1,0]:=49; TC[1,1]:=46; TC[1,2]:=49;      {*Marque l'image Format MGF 1.1*}
TC[0,0]:=70; TC[0,1]:=71; TC[0,2]:=77;
If (Save_Info) And (Error<>3) Then Begin Writeln(Fr); Writeln(Fr,'Marquage de l''image format MGF... Ok'); End;

TextColor(7);
If (Not NoMess) And (Save_Info) Then Writeln('Sauvegarde du fichier............ ',Rapport);
If Save_Info Then Writeln(Fr,'Sauvegarde du fichier............ ',Rapport);

If Error=3 Then Begin
   If Save_Info Then Close(Fr);             {*Pas besoin de Modifier l'Image*}
   Exit; End;

SAVE_MGF;

If Save_Info=True Then Close(Fr);           {*Ferme le Fichier d'informations*}
If NoMess Then Gotoxy(WhereX,WhereY-1);     {*Revient 1 ligne plus Haut*}

If Not Errorsyb Then End_tab_xms(Tab_xms);  {*Libre la mmoire XMS*}

Dispose(buff);
End.
